# Structure To Command Filter Version 3.0 by CubeCoded (http://youtube.com/cubecoded)
# Many parts of code from filters by FrodCube (http://youtube.com/frodcube)
# Thanks to @b3kstudio for reminding me to fix this for 1.8
# Built for Minecraft 1.8

from pymclevel import TAG_List
from pymclevel import TAG_Byte
from pymclevel import TAG_Int
from pymclevel import TAG_Compound
from pymclevel import TAG_Short
from pymclevel import TAG_Double
from pymclevel import TAG_String

displayName = "Structure To Command V3.0"

inputs = (
    ("Mode", ("replace", "keep", "destroy")),
	("Positioning", ("Relative", "Absolute")),
	("X offset", (0, -100, 100)),
	("Y offset", (0, -100, 100)),
	("Z offset", (0, -100, 100)),
	("Ignore Entities", False),
	)

########## Fast data access ##########
from pymclevel import ChunkNotPresent
GlobalChunkCache = {}
GlobalLevel = None

def getChunk(x, z):
	global GlobalChunkCache
	global GlobalLevel
	chunkCoords = (x>>4, z>>4)
	if chunkCoords not in GlobalChunkCache:
		try:
			GlobalChunkCache[chunkCoords] = GlobalLevel.getChunk(x>>4, z>>4)
		except ChunkNotPresent:
			return None
	
	return GlobalChunkCache[chunkCoords]

def blockAt(x, y, z):
	chunk = getChunk(x, z)
	if chunk == None:
		return 0
	return chunk.Blocks[x%16][z%16][y]

def dataAt(x, y, z):
	chunk = getChunk(x, z)
	if chunk == None:
		return 0
	return chunk.Data[x%16][z%16][y]
	
def tileEntityAt(x, y, z):
	chunk = getChunk(x, z)
	if chunk == None:
		return 0
	return chunk.tileEntityAt(x, y, z)

NonSolids = [6,8,9,10,11,23,26,27,28,31,32,36,37,38,39,40,50,51,54,55,59,61,62,63,64,65,66,68,69,70,71,72,75,76,77,78,81,83,90,92,93,94,96,104,105,106,111,115,127,130,131,132,140,141,142,143,146,147,148,149,150,152,157,158,171,175,176,177,193,194,195,196,197]

names = {"0": "air",
	"1": "stone",
	"2": "grass",
	"3": "dirt",
	"4": "cobblestone",
	"5": "planks",
	"6": "sapling",
	"7": "bedrock",
	"8": "flowing_water",
	"9": "water",
	"10": "flowing_lava",
	"11": "lava",
	"12": "sand",
	"13": "gravel",
	"14": "gold_ore",
	"15": "iron_ore",
	"16": "coal_ore",
	"17": "log",
	"18": "leaves",
	"19": "sponge",
	"20": "glass",
	"21": "lapis_ore",
	"22": "lapis_block",
	"23": "dispenser",
	"24": "sandstone",
	"25": "noteblock",
	"26": "bed",
	"27": "golden_rail",
	"28": "detector_rail",
	"29": "sticky_piston",
	"30": "web",
	"31": "tallgrass",
	"32": "deadbush",
	"33": "piston",
	"34": "piston_head",
	"35": "wool",
	"36": "piston_extension",
	"37": "yellow_flower",
	"38": "red_flower",
	"39": "brown_mushroom",
	"40": "red_mushroom",
	"41": "gold_block",
	"42": "iron_block",
	"43": "double_stone_slab",
	"44": "stone_slab",
	"45": "brick_block",
	"46": "tnt",
	"47": "bookshelf",
	"48": "mossy_cobblestone",
	"49": "obsidian",
	"50": "torch",
	"51": "fire",
	"52": "mob_spawner",
	"53": "oak_stairs",
	"54": "chest",
	"55": "redstone_wire",
	"56": "diamond_ore",
	"57": "diamond_block",
	"58": "crafting_table",
	"59": "wheat",
	"60": "farmland",
	"61": "furnace",
	"62": "lit_furnace",
	"63": "standing_sign",
	"64": "wooden_door",
	"65": "ladder",
	"66": "rail",
	"67": "stone_stairs",
	"68": "wall_sign",
	"69": "lever",
	"70": "stone_pressure_plate",
	"71": "iron_door",
	"72": "wooden_pressure_plate",
	"73": "redstone_ore",
	"74": "lit_redstone_ore",
	"75": "unlit_redstone_torch",
	"76": "redstone_torch",
	"77": "stone_button",
	"78": "snow_layer",
	"79": "ice",
	"80": "snow",
	"81": "cactus",
	"82": "clay",
	"83": "reeds",
	"84": "jukebox",
	"85": "fence",
	"86": "pumpkin",
	"87": "netherrack",
	"88": "soul_sand",
	"89": "glowstone",
	"90": "portal",
	"91": "lit_pumpkin",
	"92": "cake",
	"93": "unpowered_repeater",
	"94": "powered_repeater",
	"95": "stained_glass",
	"96": "trapdoor",
	"97": "monster_egg",
	"98": "stonebrick",
	"99": "brown_mushroom_block",
	"100": "red_mushroom_block",
	"101": "iron_bars",
	"102": "glass_pane",
	"103": "melon_block",
	"104": "pumpkin_stem",
	"105": "melon_stem",
	"106": "vine",
	"107": "fence_gate",
	"108": "brick_stairs",
	"109": "stone_brick_stairs",
	"110": "mycelium",
	"111": "waterlily",
	"112": "nether_brick",
	"113": "nether_brick_fence",
	"114": "nether_brick_stairs",
	"115": "nether_wart",
	"116": "enchanting_table",
	"117": "brewing_stand",
	"118": "cauldron",
	"119": "end_portal",
	"120": "end_portal_frame",
	"121": "end_stone",
	"122": "dragon_egg",
	"123": "redstone_lamp",
	"124": "lit_redstone_lamp",
	"125": "double_wooden_slab",
	"126": "wooden_slab",
	"127": "cocoa",
	"128": "sandstone_stairs",
	"129": "emerald_ore",
	"130": "ender_chest",
	"131": "tripwire_hook",
	"132": "tripwire",
	"133": "emerald_block",
	"134": "spruce_stairs",
	"135": "birch_stairs",
	"136": "jungle_stairs",
	"137": "command_block",
	"138": "beacon",
	"139": "cobblestone_wall",
	"140": "flower_pot",
	"141": "carrots",
	"142": "potatoes",
	"143": "wooden_button",
	"144": "skull",
	"145": "anvil",
	"146": "trapped_chest",
	"147": "light_weighted_pressure_plate",
	"148": "heavy_weighted_pressure_plate",
	"149": "unpowered_comparator",
	"150": "powered_comparator",
	"151": "daylight_detector",
	"152": "redstone_block",
	"153": "quartz_ore",
	"154": "hopper",
	"155": "quartz_block",
	"156": "quartz_stairs",
	"157": "activator_rail",
	"158": "dropper",
	"159": "stained_hardened_clay",
	"160": "stained_glass_pane",
	"161": "leaves2",
	"162": "log2",
	"163": "acacia_stairs",
	"164": "dark_oak_stairs",
	"165": "slime",
	"166": "barrier",
	"167": "iron_trap_door",
	"168": "prismarine",
	"169": "sea_lantern",
	"170": "hay_block",
	"171": "carpet",
	"172": "hardened_clay",
	"173": "coal_block",
	"174": "packed_ice",
	"175": "double_plant",
	"176": "standing_banner",
	"177": "wall_banner",
	"178": "daylight_detector_inverted",
	"179": "red_sandstone",
	"180": "red_sandstone_stairs",
	"182": "stone_slab2",
	"183": "spruce_fence_gate",
	"184": "birch_fence_gate",
	"185": "jungle_fence_gate",
	"186": "dark_oak_fence_gate",
	"187": "acacia_fence_gate",
	"188": "spruce_fence",
	"189": "birch_fence",
	"190": "jungle_fence",
	"191": "dark_oak_fence",
	"192": "acacia_fence",
	"193": "spruce_door",
	"194": "birch_door",
	"195": "jungle_door",
	"196": "acacia_door",
	"197": "dark_oak_door",
	"256": "iron_shovel",
	"257": "iron_pickaxe",
	"258": "iron_axe",
	"259": "flint_and_steel",
	"260": "apple",
	"261": "bow",
	"262": "arrow",
	"263": "coal",
	"264": "diamond",
	"265": "iron_ingot",
	"266": "gold_ingot",
	"267": "iron_sword",
	"268": "wooden_sword",
	"269": "wooden_shovel",
	"270": "wooden_pickaxe",
	"271": "wooden_axe",
	"272": "stone_sword",
	"273": "stone_shovel",
	"274": "stone_pickaxe",
	"275": "stone_axe",
	"276": "diamond_sword",
	"277": "diamond_shovel",
	"278": "diamond_pickaxe",
	"279": "diamond_axe",
	"280": "stick",
	"281": "bowl",
	"282": "mushroom_stew",
	"283": "golden_sword",
	"284": "golden_shovel",
	"285": "golden_pickaxe",
	"286": "golden_axe",
	"287": "string",
	"288": "feather",
	"289": "gunpowder",
	"290": "wooden_hoe",
	"291": "stone_hoe",
	"292": "iron_hoe",
	"293": "diamond_hoe",
	"294": "golden_hoe",
	"295": "wheat_seeds",
	"296": "wheat",
	"297": "bread",
	"298": "leather_helmet",
	"299": "leather_chestplate",
	"300": "leather_leggings",
	"301": "leather_boots",
	"302": "chainmail_helmet",
	"303": "chainmail_chestplate",
	"304": "chainmail_leggings",
	"305": "chainmail_boots",
	"306": "iron_helmet",
	"307": "iron_chestplate",
	"308": "iron_leggings",
	"309": "iron_boots",
	"310": "diamond_helmet",
	"311": "diamond_chestplate",
	"312": "diamond_leggings",
	"313": "diamond_boots",
	"314": "golden_helmet",
	"315": "golden_chestplate",
	"316": "golden_leggings",
	"317": "golden_boots",
	"318": "flint",
	"319": "porkchop",
	"320": "cooked_porkchop",
	"321": "painting",
	"322": "golden_apple",
	"323": "sign",
	"324": "wooden_door",
	"325": "bucket",
	"326": "water_bucket",
	"327": "lava_bucket",
	"328": "minecart",
	"329": "saddle",
	"330": "iron_door",
	"331": "redstone",
	"332": "snowball",
	"333": "boat",
	"334": "leather",
	"335": "milk_bucket",
	"336": "brick",
	"337": "clay_ball",
	"338": "reeds",
	"339": "paper",
	"340": "book",
	"341": "slime_ball",
	"342": "chest_minecart",
	"343": "furnace_minecart",
	"344": "egg",
	"345": "compass",
	"346": "fishing_rod",
	"347": "clock",
	"348": "glowstone_dust",
	"349": "fish",
	"350": "cooked_fished",
	"351": "dye",
	"352": "bone",
	"353": "sugar",
	"354": "cake",
	"355": "bed",
	"356": "repeater",
	"357": "cookie",
	"358": "filled_map",
	"359": "shears",
	"360": "melon",
	"361": "pumpkin_seeds",
	"362": "melon_seeds",
	"363": "beef",
	"364": "cooked_beef",
	"365": "chicken",
	"366": "cooked_chicken",
	"367": "rotten_flesh",
	"368": "ender_pearl",
	"369": "blaze_rod",
	"370": "ghast_tear",
	"371": "gold_nugget",
	"372": "nether_wart",
	"373": "potion",
	"374": "glass_bottle",
	"375": "spider_eye",
	"376": "fermented_spider_eye",
	"377": "blaze_powder",
	"378": "magma_cream",
	"379": "brewing_stand",
	"380": "cauldron",
	"381": "ender_eye",
	"382": "speckled_melon",
	"383": "spawn_egg",
	"384": "experience_bottle",
	"385": "fire_charge",
	"386": "writable_book",
	"387": "written_book",
	"388": "emerald",
	"389": "item_frame",
	"390": "flower_pot",
	"391": "carrot",
	"392": "potato",
	"393": "baked_potato",
	"394": "poisonous_potato",
	"395": "map",
	"396": "golden_carrot",
	"397": "skull",
	"398": "carrot_on_a_stick",
	"399": "nether_star",
	"400": "pumpkin_pie",
	"401": "fireworks",
	"402": "firework_charge",
	"403": "enchanted_book",
	"404": "comparator",
	"405": "netherbrick",
	"406": "quartz",
	"407": "tnt_minecart",
	"408": "hopper_minecart",
	"409": "prismarine_shard",
	"410": "prismarine_crystals",
	"411": "rabbit",
	"412": "cooked_rabbit",
	"413": "rabbit_stew",
	"414": "rabbit_foot",
	"415": "rabbit_hide",
	"416": "armor_stand",
	"417": "iron_horse_armor",
	"418": "golden_horse_armor",
	"419": "diamond_horse_armor",
	"420": "lead",
	"421": "name_tag",
	"422": "command_block_minecart",
	"423": "mutton",
	"424": "cooked_mutton",
	"425": "banner",
	"427": "spruce_door",
	"428": "birch_door",
	"429": "jungle_door",
	"430": "acacia_door",
	"431": "dark_oak_door",
	"2256": "record_13",
	"2257": "record_cat",
	"2258": "record_blocks",
	"2259": "record_chirp",
	"2260": "record_far",
	"2261": "record_mall",
	"2262": "record_mellohi",
	"2263": "record_stal",
	"2264": "record_strad",
	"2265": "record_ward",
	"2266": "record_11",
	"2267": "record_wait"}

########## End fast data access ##########

def perform(level, box, options):
	global GlobalLevel
	GlobalLevel = level
	
	total = 0
	blocksToSpawn = []
	entities = []
	for x in xrange(box.minx, box.maxx):
		for z in xrange(box.minz, box.maxz):
			for y in reversed(xrange(box.miny, box.maxy)):
				if (level.blockAt(x, y, z) != 0):
					(id, meta) = (blockAt(x, y, z), dataAt(x, y, z))
					te = ""
					if tileEntityAt(x, y, z) != None:
						te = str(tileEntityAt(x, y, z))
						te = CleanTAG(te)
					blocksToSpawn.append((x, y, z, id, meta, te))
					total += 1
	
	for (chunk, slices, point) in level.getChunkSlices(box):	
		for entity in chunk.Entities:
			x = int(entity["Pos"][0].value)
			y = int(entity["Pos"][1].value)
			z = int(entity["Pos"][2].value)
			
			if x >= box.minx and x < box.maxx and y >= box.miny and y < box.maxy and z >= box.minz and z < box.maxz:
				ent = str(entity)
				ent = CleanTAG(ent)
				entities.append((entity["Pos"][0].value, entity["Pos"][1].value, entity["Pos"][2].value, entity["id"].value, ent))
				
				total += 1
		
	cx = box.maxx + options["X offset"]
	cy = box.miny + options["Y offset"]
	cz = box.maxz + options["Z offset"]
	mode = options["Mode"]
	positioning = options["Positioning"]
	ignoreEntities = options["Ignore Entities"]
	
	command = "summon MinecartCommandBlock ~ ~1 ~ {Command:tp @e[type=MinecartCommandBlock,dx=0,dz=0,y=255,dy=255] @e[type=WitherSkull,c=1,name=CubeCoded],Riding:{id:MinecartCommandBlock,Riding:{id:MinecartCommandBlock,Command:summon WitherSkull ~ ~ ~ {direction:[],CustomName:CubeCoded},Riding:{id:FallingSand,TileID:157,Time:1,DropItem:0}},Command:summon MinecartCommandBlock ~ 255 ~ {Command:kill @e[type=WitherSkull,name=CubeCoded,c=1],"
	endcommand = "}}}"
	
	modes = (True, False)
	for nonsolid in modes:
		for (x, y, z, id, meta, te) in blocksToSpawn:
				
			if (not nonsolid) and id not in NonSolids:
				continue
			if nonsolid and (id in NonSolids or id == 0):
				continue
			
			endcommand = endcommand + "}"
			
			if positioning == "Relative":
				if te == "" and mode == "replace":
					command = command + "Riding:{id:MinecartCommandBlock,Command:setblock ~" + str(x-cx) + " ~" + str(y-cy-1) + " ~" + str(z-cz) + " " + names[str(id)] + " " + str(meta) + ","
				else:
					command = command + "Riding:{id:MinecartCommandBlock,Command:setblock ~" + str(x-cx) + " ~" + str(y-cy-1) + " ~" + str(z-cz) + " " + names[str(id)] + " " + str(meta) + " " + mode + " " + te + ","
			else:
				if te == "" and mode == "replace":
					command = command + "Riding:{id:MinecartCommandBlock,Command:setblock " + str(x) + " " + str(y) + " " + str(z) + " " + names[str(id)] + " " + str(meta) + ","
				else:
					command = command + "Riding:{id:MinecartCommandBlock,Command:setblock " + str(x) + " " + str(y) + " " + str(z) + " " + names[str(id)] + " " + str(meta) + " " + mode + " " + te + ","
			
	if ignoreEntities == False:
		for (x, y, z, id, ent) in entities:
			
			endcommand = endcommand + "}"
			
			if positioning == "Relative":
				command = command + "Riding:{id:MinecartCommandBlock,Command:summon " + id + " ~" + str(x-cx-0.5) + " ~" + str(y-cy-1) + " ~" + str(z-cz-0.5) + " " + ent + ","
			else:
				command = command + "Riding:{id:MinecartCommandBlock,Command:summon " + id + " " + str(x) + " " + str(y) + " " + str(z) + " " + ent + ","
	
	command = command + "Riding:{id:MinecartCommandBlock,Command:kill @e[type=MinecartCommandBlock,dx=0,dz=0,y=1,dy=255]}" + endcommand
		
	if len(command) > 32750:
		raise Exception("Your structure is too big to fit in one command block! Try selecting portions of the blocks and separating it into pieces.")
	else:
		CreateCommandBlock(level, cx, cy, cz, command, len(blocksToSpawn), len(entities))
	
def CreateCommandBlock(level, ox, oy, oz, command, numblock, nument):
	level.setBlockAt(ox, oy, oz, 137)
	level.setBlockAt(ox+1, oy, oz, 77)
	level.setBlockDataAt(ox+1, oy, oz, 1)
	level.setBlockAt(ox, oy+1, oz, 68)
	level.setBlockDataAt(ox, oy+1, oz, 5)
	
	control = TAG_Compound()
	control["Command"] = TAG_String(command)
	control["id"] = TAG_String("Control")
	control["x"] = TAG_Int(ox)
	control["y"] = TAG_Int(oy)
	control["z"] = TAG_Int(oz)
	level.addTileEntity(control)
	
	control = TAG_Compound()
	control["Text1"] = TAG_String("Blocks:"+str(numblock))
	control["Text2"] = TAG_String("Entities:"+str(nument))
	control["Text4"] = TAG_String("by CubeCoded")
	control["id"] = TAG_String("Sign")
	control["x"] = TAG_Int(ox)
	control["y"] = TAG_Int(oy+1)
	control["z"] = TAG_Int(oz)
	level.addTileEntity(control)
	
def CleanTAG(te):
	tileEntity = te
	
	while '  ' in tileEntity:
		tileEntity = tileEntity.replace('  ', ' ')
	
	tileEntity = tileEntity.replace("\"", '')
	tileEntity = tileEntity.replace("(", '')
	tileEntity = tileEntity.replace(")", '')
	tileEntity = tileEntity.replace("TAG_List", '')
	tileEntity = tileEntity.replace("TAG_Byte", '')
	tileEntity = tileEntity.replace("TAG_Short", '')
	tileEntity = tileEntity.replace("TAG_Int", '')
	tileEntity = tileEntity.replace("TAG_Long", '')
	tileEntity = tileEntity.replace("TAG_Float", '')
	tileEntity = tileEntity.replace("TAG_Double", '')
	tileEntity = tileEntity.replace("TAG_String", '')
	tileEntity = tileEntity.replace("TAG_Byte_Array", '')
	tileEntity = tileEntity.replace("TAG_Int_Array", '')
	tileEntity = tileEntity.replace("TAG_Compound", '')
	tileEntity = tileEntity.replace("u'", '')
	tileEntity = tileEntity.replace("'", '')
	tileEntity = tileEntity.replace("\n", '')
	tileEntity = tileEntity.replace("{ ", '{')
	tileEntity = tileEntity.replace("[ ", '[')
	tileEntity = tileEntity.replace(", ", ',')
	tileEntity = tileEntity.replace(",}", '}')
	tileEntity = tileEntity.replace(",]", ']')
	
	return tileEntity